//+------------------------------------------------------------------+
//|                                   double smoothed ema ribbon.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 DarkOrange
#property indicator_color3 DimGray
#property indicator_color4 DimGray
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern string TimeFrame    = "current time frame";
extern int    EMA1Period   = 20;
extern int    EMA1Price    = PRICE_CLOSE;
extern int    EMA2Period   = 50;
extern int    EMA2Price    = PRICE_CLOSE;
extern bool   Interpolate   = true;

//
//
//
//
//

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   calculateValue;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,trend);
      if (EMA1Period>EMA2Period)
      {
         int temp = EMA1Period;
                    EMA1Period = EMA2Period;
                    EMA2Period = temp;
      }                    

      //
      //
      //
      //
      //
         
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");      if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue");  if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars)  { buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      double alpha1 = 2.0 /(1.0+MathSqrt(EMA1Period));
      double alpha2 = 2.0 /(1.0+MathSqrt(EMA2Period));
     
      for(i=limit; i>=0; i--)
      {
         double price1 = iMA(NULL,0,1,0,MODE_SMA,EMA1Price,i);
         double price2 = iMA(NULL,0,1,0,MODE_SMA,EMA2Price,i);
         if (i==Bars-1)
         {
            buffer1[i] = price1; buffer3[i] = price1; buffer5[i] = price1;
            buffer2[i] = price2; buffer4[i] = price2; buffer6[i] = price2;
            continue;
         }
      
         //
         //
         //
         //
         //
         
         buffer5[i] = buffer5[i+1] + alpha1*(price1    -buffer5[i+1]);
         buffer1[i] = buffer1[i+1] + alpha1*(buffer5[i]-buffer1[i+1]);
         buffer6[i] = buffer6[i+1] + alpha2*(price2    -buffer6[i+1]);
         buffer2[i] = buffer2[i+1] + alpha2*(buffer6[i]-buffer2[i+1]);
         buffer3[i] = buffer1[i];
         buffer4[i] = buffer2[i];
         trend[i]   = trend[i+1];
      
            if (buffer1[i]>buffer2[i]) trend[i] =  1;
            if (buffer1[i]<buffer2[i]) trend[i] = -1;
      }
      if (!calculateValue) manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",EMA1Period,EMA1Price,EMA2Period,EMA2Price,0,y);
         buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",EMA1Period,EMA1Price,EMA2Period,EMA2Price,1,y);
         buffer3[i] = buffer1[i];
         buffer4[i] = buffer2[i];
         trend[i]   = trend[i+1];
            if (buffer1[i]>buffer2[i]) trend[i] =  1;
            if (buffer1[i]<buffer2[i]) trend[i] = -1;

         //
         //
         //
         //
         //
      
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
            for(int k = 1; k < n; k++)
            {
               buffer1[i+k] = k*factor*buffer1[i+n] + (1.0-k*factor)*buffer1[i];
               buffer2[i+k] = k*factor*buffer2[i+n] + (1.0-k*factor)*buffer2[i];
               buffer3[i+k] = buffer1[i+k];
               buffer4[i+k] = buffer2[i+k];
            }
   }
   manageAlerts();

   //
   //
   //
   //
   //
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(timeFrame)+" DS ema "+EMA1Period+" crossed DS ema "+EMA2Period+" ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"DS ema "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}